<h1 align="center" name="pywebio-en">Restic UI</h1>
<p align="center">
    <em>Webinterface for Restic, created with PyWebIO</em>
</p>
<p align="center">
    <a href="https://pylint.org/">
        <img src="https://img.shields.io/badge/linting-pylint-yellowgreen" alt="Linting">
    </a>
    <a href="https://pypi.org/project/flake8/">
        <img src="https://img.shields.io/badge/linting-flake8-yellowgreen" alt="Linting">
    </a>
    <a href="https://www.python.org/">
        <img src="https://img.shields.io/badge/python->%3D%203.10.1-brightgreen" alt="Python Version">
    </a>
    <a href="https://www.pyweb.io/">
        <img src="https://img.shields.io/badge/pywebio->%20%201.7.1-brightgreen" alt="Python Version">
    </a>
    <a href="https://www.gnu.org/licenses/gpl-3.0.en.html">
        <img src="https://img.shields.io/gitlab/license/Bullet64/restic_ui_pywebio?color=yellow" alt="License">
    </a>
</p>

# restic_ui_pywebio

## About

This project is not related to [restic.net](https://restic.net)

This is my Restic UI created with 'low code framework [pywebio](https://www.pyweb.io/)'.

The project is a UI for the CLI tool [restic](https://restic.net)

This project is quite far from perfect, but it helped me a lot to understand the world of Python, PyCharm and git a little.

If it helps someone along the way as well, I'm glad. For questions and suggestions you can write me in my [forum](https://linux-nerds.org/category/62/pywebio)

And now have fun with one of the best backup tools!

## Dependencies

* restic
* python >= 3.10
* pipenv
* git

## Functions Restic-UI

**The data of the backup database can be stored encrypted. For this purpose, there is a key file that can be stored in a safe place.**

Restic functions that are included in the UI

* init
* backup
* mount
* restore
* snapshots
* ls
* check
* unlock
* stats
* prune
* version
* migrate check
* migrate update

Restic REST-Backend Functions included

* init
* backup
* mount
* restore
* snapshots
* ls
* check
* unlock
* stats
* prune

Source: https://github.com/restic/rest-server

## Installation

### Install restic if not installed

    apt install git
    apt install restic
    restic self-update

### Clone Repository

    git clone https://gitlab.com/Bullet64/restic_ui_pywebio.git

### Create env

    cd /home/USER/restic-ui-pywebio

    We upgrade to last pip version
    python -m pip install -U pip
    pip install pipenv
    pip install pywebio

    pipenv --python 3.10
    pipenv shell

### Create env with uv

    cd /home/USER/restic-ui-pywebio
    uv init
    uv venv --python 3.13
    source .venv/bin/activate   
    uv add pywebio
    uv add pywebio_battery

## Usage

    python main.py

## Known problems

    None at present

![main screen](/images/restic_screen.png "Restic Screen")    

## Tested on

* Manjaro 22.2.0 Sikaris
* Linux Mint 21 Cinnamon

with

* python >= 3.10
